using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.AnalysisServices.AdomdClient;
using System.Data;

namespace AdomdIterateActions
{
	class Program
	{
		static void Main(string[] args)
		{
			//Open a connection to the server
			AdomdConnection con = new AdomdConnection();
			con.ConnectionString = "Datasource=localhost; Initial Catalog=Foodmart 2008;Safety Options=1";
			con.Open();

			//Create a collection of restrictions for GetSchemaDataSet
			AdomdRestrictionCollection restrictions = new AdomdRestrictionCollection();
			restrictions.Add("CATALOG_NAME", "Foodmart 2008");
            restrictions.Add("CUBE_NAME", "Warehouse And Sales");
            restrictions.Add("COORDINATE", "[Store].[Store City].[Los Angeles]");
			int coordinateType = 4; // MDACTION_COORDINATE_MEMBER
			restrictions.Add("COORDINATE_TYPE", coordinateType/*.ToString()*/);
			restrictions.Add("INVOCATION", 0);

			//Call the method GetSchemaDataSet
			DataSet ds = con.GetSchemaDataSet("MDSCHEMA_ACTIONS", restrictions);

			//Iterate all the rows in the first table of the Dataset
			// Print the contents of each column.
			foreach (DataRow row in ds.Tables[0].Rows)
			{
				foreach (DataColumn column in ds.Tables[0].Columns)
				{
					Console.WriteLine(column.Caption + "=" + row[column]);
				}
			}

			//Close the connection
			con.Close();
		}
	}
}
